#!/usr/local/bin/python
# Copyright (C) Johan Ceuppens 2011
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *

from maproom1 import *
from maproom2 import *
from maproom2_1 import *

from taskbar import *
from time import *
from inventory import *
from meter import *
from playerkattafighter import*
from playerlink import *

from inventorybow1 import *
from inventoryknife1 import *

class Game:
    "Main function"
    def __init__(self):
        pygame.init()
        pygame.font.init()
        screen = pygame.display.set_mode((640, 480))
        font = pygame.font.SysFont("Times", 14)
        font2 = pygame.font.SysFont("Coutier", 36)
        font3 = pygame.font.SysFont("Vera", 52)
        gameover = 0

        askplayers = 0 # NOTE: 2 Player flag
        
        blankimage = pygame.image.load('./pics/blank.bmp').convert()
        ## There are several title screens in the ./pics/ directory
        titleimage = pygame.image.load('./pics/titlescreen.bmp').convert()
        self.x = 0
        self.y = 0
        
        #self.room = Maproom2_1(-3400,-800)
        #self.room = Maproom2(100,0)
        self.room = Maproom1(0,0)
        heartmeter = Meter()
        player = PlayerLink(heartmeter)
##        selector = Selector(screen, font)
##
##        selector.select()
##        
##	heartmeter = Meter()
##	player = PlayerFighter(heartmeter)##default fighter class
##	if selector.askrace() == "Human":
##            if selector.askclass() == "Fighter":
##                player = PlayerHumanFighter(heartmeter)
##            elif selector.askclass() == "Magic User":
##                player = PlayerMagicUser(heartmeter)
##        if selector.askrace() == "Bugbear":
##            if selector.askclass() == "Fighter":
##                player = PlayerGnollFighter(heartmeter)
##        if selector.askrace() == "Katta":
##            if selector.askclass() == "Fighter":
##                player = PlayerKattaFighter(heartmeter)
##        if selector.askrace() == "Elven":
##            if selector.askclass() == "Fighter":
##                player = PlayerElfFighter(heartmeter)
##        if selector.askrace() == "Abeille":
##            if selector.askclass() == "Fighter":
##                player = PlayerAbeilleFighter(heartmeter)
##        
##        player2 = None
##
        pygame.key.set_repeat(10,100)
        self.keydown = 0
        
        self.taskbar = Taskbar(screen,font,player)
        self.talker = None
        gameflag = 0
        while gameover == 0:
            pygame.display.update()
            screen.blit(titleimage, (0,0))
            sleep(0.01)
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    gameover = 1
                if event.type == pygame.MOUSEBUTTONDOWN:
                    gameover = 1

            
        gameover = 0
        while gameover == 0:
            player.h = 72 # NOTE: for ducking, FIXME 48
            sleep(0.01)
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
            	    self.keydown = 1
                    # player 1 key controls
                    
                    if event.key == K_x:
                        if self.room.collide(player) == 4:# FIXME2
                            self.talker = self.room.talkto() 
                            print "self.talker=%s" % self.talker
##			if self.talker == None:
##                        	id = player.pickup(self.room)
##				if id == 5:
##		                	self.taskbar.setrubysword()
##					player.setrubysword()
                    elif event.key == K_z:
                        player.fight(self.room,self,player)
                    #elif event.key == K_SPACE:
                    #    player.fight(self.room,self,player)
##                    elif event.key == K_UP:
##                        self.room.movedown()    
                    elif event.key == K_DOWN:
                        self.keydown = 2
                        
                        #FIXME keydown = 2
                        #self.room.moveup()    
                    elif event.key == K_LEFT:
                        self.room.moveright()
                        self.room.direction = "left"
                        player.direction = "left"#FIXME
                    elif event.key == K_RIGHT:
                        self.room.moveleft()
                        self.room.direction = "right"
                        player.direction = "right"
                    elif event.key == K_UP:
                        roomnumber = self.room.exit(self)
                        self.chooseroom(roomnumber,font)
                        if roomnumber == 0:
                            
                            if self.room.fall(player) == 2:
                                player.jump(self.room)    
                           
                    elif event.key == K_i:
#                        self.level.gameover = 1
                      #FIXME  pygame.event.flush()
                        flag = 0
                        inventory = Inventory()
		
			##if Scrollinvisibility(0,0,0,0,"1","1").readkeys(None):
                        ##    inventory.additem(Inventoryscrollinvisibility())
                        if self.room.inventoryknife1 == 1:
                       		inventory.additem(Inventoryknife1())
			if self.room.inventorymasterkey == 1:
                       		1###FIX for key in inventory.additem(Inventorymasterkey())
                        if self.room.inventorykey1 == 1:
                       		1###FIX for key in inventory.additem(Inventorykey1())
                       	if self.room.inventorykey2 == 1:
                       		1###FIX for key in inventory
                       	if self.room.inventorybow1 == 1:
                                inventory.additem(Inventorybow1())
                       		###FIX for key in inventory
			while flag == 0:#NOTE1
                            sleep(0.01)
                            for event in pygame.event.get():
                                if event.type == QUIT:
                                    return

                                elif event.type == KEYDOWN:
                                    if event.key == K_LEFT:
                                        inventory.moveleft()
                                    elif event.key == K_RIGHT:
                                        inventory.moveright()
                                    elif event.key == K_z or event.key == K_x:
                                        self.room.inventoryitem = inventory.getitem(self.room.inventoryitem)
                                        if self.room.inventoryitem:
                                            self.room.inventoryitem.setintaskbar(self.taskbar)
                                        flag = 1


                                inventory.draw(screen)
                                pygame.display.update()
 
	    pickupid = self.room.pickup(player)
	    if pickupid:
                str = ""
		if pickupid == 5: # NOTE : key1 id
		    self.room.inventorykey1 = 1
		    str = "You found a key."
		    gameflag = 0
		elif pickupid == 6: # NOTE : masterkey id
		    #self.room.inventorymasterkey = 1
		    str = "You healed."
		    gameflag = 0
		    player.hitpoints = player.maxhitpoints
		elif pickupid == 7: # NOTE : masterkey id
		    self.room.inventorymasterkey1 = 1
		    str = "You found a key."
		    gameflag = 0
		elif pickupid == 8: # NOTE : masterkey id
		    self.room.inventorybow1 = 1
		    #player.setbow()
		    #taskbar.setbow()
		    str = "You found a bow."
		    gameflag = 0
		    #do not set automatically self.taskbar.setbow()
		else:
                    gameflag = 1
                while gameflag == 0:
                    pygame.key.set_repeat(1000,1000)
                    screen.blit(blankimage, (0,0))
                    self.taskbar.draw(self)
                    heartmeter.draw(screen)
                    self.room.draw(screen,player)
                    player.update(self.room)
                    self.taskbar.draw(self)
                    screen.blit(font3.render(str, 8, (255,255,255)), (10,100))
                    
                    pygame.display.update()
                    sleep(0.01)
                    for event in pygame.event.get():
                        if event.type == QUIT:
                            return
                        elif event.type == KEYDOWN:
                            if (event.key == K_x or
                                  event.key == K_z):
                                    gameflag = 1                       
                pygame.key.set_repeat(10,100)
#		elif pickupid == 2: ## NOTE: dungeonentrance 2 id opens with key 1
#                    if self.inventorykey1 == 1:
#                        self.room.removeentrance2()
#                elif pickupid == 3: # NOTE dungeon key 1 id
#                    self.inventorykey1 = 1
#                elif pickupid == 4: # NOTE dungeon key 2 id
#                    self.inventorykey2 = 1
#                elif pickupid == 5: # NOTE ruby sword id
#                    self.inventoryrubysword = 1
#                    self.taskbar.setrubysword()
                    
            if self.room.collide(player) == 1 or player.hitpoints <= 0: # NOTE: return 1 after player heartmeter runs out (player.hit)
        	endingimage = pygame.image.load('./pics/endingscreen.bmp').convert()
        	while gameover == 0:
	            	pygame.display.update()
        	    	screen.blit(endingimage, (0,0))
        	    	sleep(0.01)
            		for event in pygame.event.get():
                		if event.type == QUIT:
                    			return
                		elif event.type == KEYDOWN:
                    			gameover = 1
					return
                		if event.type == pygame.MOUSEBUTTONDOWN:
                    			gameover = 1
					return
				    
            #if self.room.collide(player) == 3 or self.room.collide(player) == 2:###Dungeon wall
	    
            #elif self.room.relativey > prevy:
            #    self.room.relativey -= abs(prevy-self.room.relativey)
                #self.room.undomoveX()
            if self.room.collidewithropes(player) == 2:
                
                while gameflag == 0:
                    sleep(0.01)
                    for event in pygame.event.get():
                        if event.type == QUIT:
                            return
                        elif event.type == KEYDOWN:
            	    
                            # player 1 key controls
                            ##player.draw(screen)
                            ##if event.key == K_z:
                             ##   player.fight(self.room)  
                            if event.key == K_UP:
                                if self.room.collidewithropes(player) == 2:
                                    self.room.movedown()   
                            elif event.key == K_DOWN:
##                              if at the end of the rope, have to jump off  
                                if self.room.collidewithropes(player) == 2:
                                    self.room.moveup()
                            elif event.key == K_RIGHT:
                                self.room.moveleft()
                                gameflag = 1    
                            elif event.key == K_LEFT:
                                self.room.moveright()
                                gameflag = 1
                            if event.key == K_z:
                                player.fight(self.room,self,player)
                            elif event.key == K_x:
                                gameflag = 1
                            
                    sleep(0.05)
                    self.room.draw(screen,player)
                    player.update(self.room)
                    player.drawclimbing(screen)
                    self.taskbar.draw(self)
                    heartmeter.draw(screen) 
                    pygame.display.update()
                    screen.blit(blankimage, (0,0))

            # update player (jump) before fall
            #if ((not (self.room.collideX(player) and self.room.collideY(player)))
            #    or
            if self.room.collideXY(player) == 5:
            	self.room.undomoveX()
        	self.room.undomoveX()
        	#self.room.undomoveX()
        	    
            self.room.draw(screen,player)
            player.update(self.room)
            f = self.room.fall(player)
            if f == 2:                
                #self.room.undomove()
                gameflag = 0
            elif f == 0:
                
                if self.room.relativey < self.room.h:
                    endingimage = pygame.image.load('./pics/endingscreen.bmp').convert()
                    while gameover == 0:
                            pygame.display.update()
                            screen.blit(endingimage, (0,0))
                            sleep(0.01)
                            for event in pygame.event.get():
                                    if event.type == QUIT:
                                            return
                                    elif event.type == KEYDOWN:
                                            gameover = 1
                                            return
                                    if event.type == pygame.MOUSEBUTTONDOWN:
                                            gameover = 1
                                            return
                                        #gameflag = 1
##
            
            #if self.room.relativey < prevy:
            #    self.room.relativey = prevy#abs(prevy-self.room.relativey)

            print 'room-player x=%d y=%d' % (self.room.relativex,self.room.relativey)
            
            if self.keydown == 1:
                self.keydown = 0
                player.draw(screen)
            elif self.keydown == 2:
                self.keydown = 2
                player.drawduck(screen)
                player.h = 32
            else:
                player.drawstatic(screen)
            
            #player.draw(screen)
	    
            # fight for enemies
            # remove dead game objects

	    ### Set player hitpoints in life bar
	    heartmeter.index = player.hitpoints

            for o in self.room.gameobjects:
                if o:
                    o.fight(self.room,player)
            for o in self.room.gameobjects:
                if o and o.hitpoints <= 0:
                    self.room.removeobject(o)

            if self.talker != None:
                self.talker.talk(screen,font2)

            self.taskbar.draw(self)
            heartmeter.draw(screen)
            
            pygame.display.update()
            screen.blit(blankimage, (0,0))
            


    def sethitf(self, hitf):
        for i in self.room.gameobjects:
            i.hitf = hitf

    def setxy(self,xx,yy):
        self.x = xx
        self.y = yy

    # NOTE: set x y in maproom1 and Game() will set it with game.x (self.x) etc. 
    def chooseroom(self, roomnumber,font):
        if (roomnumber == 0):
            return
        # NOTE: 1_X  woods around haunted castle
        elif (roomnumber == 1):
            self.talker = None
            self.room = Maproom1(self.x,self.y)
        # rooms of haunted castle    
        elif (roomnumber == 2):
            self.talker = None
            self.room = Maproom2(self.x,self.y)
        elif (roomnumber == 2.1):
            self.talker = None
            self.room = Maproom2_1(self.x,self.y)
        elif (roomnumber == 2.2):
            self.talker = None
            self.room = Maproom2_2(self.x,self.y)
        elif (roomnumber == 3):
            self.talker = None
            self.room = Maproom3(self.x,self.y)
        elif (roomnumber == 4):
            self.talker = None
            self.room = Maproom4(self.x,self.y)
        elif (roomnumber == 5):
            self.talker = None
            self.room = Maproom5(self.x,self.y)
        elif (roomnumber == 6):
            self.talker = None
            self.room = Maproom6(self.x,self.y)
        elif (roomnumber == 7):
            self.talker = None
            self.room = Maproom7(self.x,self.y)
        elif (roomnumber == 8):
            self.talker = None
            self.room = Maproom8(self.x,self.y)
        elif (roomnumber == 9):
            self.talker = None
            self.room = Maproom9(self.x,self.y)
        elif (roomnumber == 10):
            self.talker = None
            self.room = Maproom10(self.x,self.y)
        elif (roomnumber == 11):
            self.talker = None
            self.room = Maproom11(self.x,self.y)
        elif (roomnumber == 12):
            self.talker = None
            self.room = Maproom12(self.x,self.y)
        elif (roomnumber == 13):
            self.talker = None
            self.room = Maproom13(self.x,self.y)
        elif (roomnumber == 14):
            self.talker = None
            self.room = Maproom14(self.x,self.y)
        # set sword parameters
        #if self.room.inventoryrubysword:
        #    self.sethitf(self.room.gameobjects.hit2)
            
if __name__ == "__main__":
    foo = Game()



