
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from maproomdungeonnorthwall import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from tilebox import *
from rope import *
#from snake1 import *
from rubysword import *
from beholder import *
from beholderbat import *
from abeille import *
from abeille2 import *
from bullfrog import *
from bullfrog2 import *
from bullfrog3 import *
from bullfrog4 import *
from bullfrog5 import *
from scorpionred1 import *
from scorpionred2 import *
from scorpionred3 import *
from scorpionred4 import *
from spider1 import *
from spider2 import *
from cavespider1 import *
from skeleton1 import *
from roadsign import *
from ghostwandering import *
from ghostcircling import *
from ghostcircling2 import *

class Maproom1(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load('./pics/bg1-2000x600.bmp').convert()
        ###self.northwall1 = Tilebox(1,1,60,48,16,1,'./pics/walldungeonnorth2-beholderglass-60x48.bmp')
##        self.northwall1 = Tilebox(1,1,60,48,13,1,'./pics/walldungeonnorth1-60x48.bmp')
##        self.southwall1 = Tilebox(1,200,30,48,13,1,'./pics/walldungeonsouth1-30x48.bmp')
##        self.westwall1 = Tilebox(360,200,48,60,1,10,'./pics/walldungeonwest1-48x60.bmp')
##        self.eastwall1 = Tilebox(775,1,48,60,1,14,'./pics/walldungeoneast1-48x60.bmp')
##        self.tileboxes.append(self.northwall1)
##        self.tileboxes.append(self.westwall1)
##        self.tileboxes.append(self.eastwall1)
##        self.tileboxes.append(self.southwall1)

        # left NOTE!!! : boxes collide so put them after enemies and roadsigns !
##        self.gameobjects.append(CaveSpider1(150,90))
##        self.gameobjects.append(CaveSpider1(200,90))
##        #self.gameobjects.append(Skeleton1(700,525))
        #self.gameobjects.append(Skeleton1(2000,525))
        self.h = -500
               


##        self.gameobjects.append(Abeille2(600,280)) 
##        self.gameobjects.append(Abeille2(700,280))
##
##        self.gameobjects.append(Abeille2(1000,280)) 
##        self.gameobjects.append(Abeille2(1100,280)) 
        #self.gameobjects.append(Bullfrog(1100,300))
        
##        self.gameobjects.append(Bullfrog(1800,300))
##        self.gameobjects.append(Bullfrog(2000,300))
        

        # left NOTE!!! : boxes collide so put them after enemies !
        self.roadsign = RoadSign(920,540)#FIXME
        self.gameobjects.append(self.roadsign)

        self.gameobjects.append(Bullfrog(700,340))
        self.gameobjects.append(Bullfrog(1800,340))
        self.gameobjects.append(Bullfrog(1500,340))
        self.gameobjects.append(Bullfrog5(170,270,500))
        self.gameobjects.append(Bullfrog4(100,0,700))
        
        #self.gameobjects.append(GhostWandering(100,500))
        #self.gameobjects.append(GhostWandering(150,500))
        self.gameobjects.append(GhostCircling(100,500,150,500))

        self.gameobjects.append(Box(0,400,900,12))
        self.gameobjects.append(Box(950,400,1050,12))
        
        # ropes       
        #self.ropes.append(Rope(980,375,140))
        # floor under rope
        self.gameobjects.append(Box(0,610,2400,12))
        # outer walls
        self.gameobjects.append(Box(0,0,12,1000))
        self.gameobjects.append(Box(950,0,12,1000))

        self.locationtext = "Woods of the Moon Elves"
        
    def draw(self,screen,player):
        sleep(0.05) # FIXME in each room
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
		
    def isroomdoorexitleft(self,game):
	if self.relativex  > 160 and self.relativex < 270 and self.relativey < -200:
		return 1
	return 0

    def setxyfromdoorleft(self,game):
       game.x = -530
       game.y = 40

    def isroomdoorexitright(self,game):
	if self.relativex  < -1500 and self.relativex > -1550 and self.relativey < -200:
		return 1
	return 0

    def setxyfromdoorright(self,game):
        game.x = 0
        game.y = 0

    def exit(self, game):
	if self.isroomdoorexitleft(game):
		self.setxyfromdoorleft(game)
		return 2.1 #NOTE1
	if self.isroomdoorexitright(game):
		self.setxyfromdoorright(game)
		return 3
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
            print "talk to in maproom 1"
            ## return self.koboldwiz
            self.roadsign.talkcounter = 1
            return self.roadsign
