
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from koboldwizard import *
from time import *

class MaproomBase:
    "Room with a (big) map"
    def __init__(self,x,y):
        ###Room.__init__(self)
        self.prevx = x
        self.prevy = y
        self.relativex = x
        self.relativey = y 
        self.background = pygame.image.load('./pics/blank.bmp').convert()
        self.direction = "east"

        self.locationtext = ""

        self.inventoryitem = None
        self.inventoryknife1 = 1
        self.inventorymasterkey = None
        self.inventorykey1 = None
        self.inventorykey2 = None
        self.inventoryrubysword = None
        self.inventorybow1 = None
        
    def draw(self,screen):
	##print "x=%d" % self.relativex 
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))

    def undomove(self):
        # FIXME 
##        if self.direction == "north":
##            self.movedown()
##            #self.movedown()
##        elif self.direction == "south":
##            self.moveup()
##            #self.moveup()
        if self.direction == "west" or self.direction == "left":
            self.moveright()
            #self.moveright()
        elif self.direction == "east" or self.direction == "right":
            self.moveleft()
        elif self.direction == "north" or self.direction == "up":
            self.movedown()
        elif self.direction == "south" or self.direction == "down":
            self.moveup()
            #self.moveleft()

    def undomoveY(self):
        # FIXME 
##        if self.direction == "north":
##            self.movedown()
##            #self.movedown()
##        elif self.direction == "south":
##            self.moveup()
##            #self.moveup()
        if self.direction == "north" or self.direction == "up":
            self.relativey += 10
        elif self.direction == "south" or self.direction == "down":
            self.relativey -= 10
            #self.moveleft()

    def undomoveX(self):
        # FIXME 
        if self.direction == "west" or self.direction == "left":
            #self.direction = "east"
            self.relativex -= 10
            #self.moveright()
        elif self.direction == "east" or self.direction == "right":
            #self.direction = "west"
            self.relativex += 10
            #self.moveright()

    def moveup(self):
        #self.direction = "north"
        self.relativey = self.relativey - 10

    def movedown(self):
        #self.direction = "south"
        self.relativey = self.relativey + 10

    def moveleft(self):
        #self.direction = "west"
        self.relativex = self.relativex - 10

    def moveright(self):
        #self.direction = "east"
        self.relativex = self.relativex + 10

    def setxyup(self):
        self.x = -80 
        self.y = -80

    def setxydown(self):
        self.x = -80 
        self.y = -80

    def talkto(self):
        return None

    def collideXX(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collideXX(self,player)
		if id:
			return id ## NOTE : returns collided entity (single)
##		self.relativex = self.prevx
##		self.relativey = self.prevy
        return None

    def collideX(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collideX(self,player)
		if id:
			return id ## NOTE : returns collided entity (single)
##		self.relativex = self.prevx
##		self.relativey = self.prevy
        return None

    def collideY(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collideY(self,player)
		if id:
			return id ## NOTE : returns collided entity (single)
##		self.relativex = self.prevx
##		self.relativey = self.prevy
        return None

    def collideXY(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collideXY(self,player)
		if id:
			return id ## NOTE : returns collided entity (single)
##		self.relativex = self.prevx
##		self.relativey = self.prevy
        return None

    def pickup(self, player):
        for i in range(0,len(self.gameobjects)):
	    o = self.gameobjects[i]
            if o and o.collidepickup(self,player):
                id = o.pickup(player)
		self.gameobjects[i] = None
                return id# FIX 
        return 0



    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	c = i.collide(self,player)
		if c:
			return i ## NOTE : returns collided entity (single)
##		self.relativex = self.prevx
##		self.relativey = self.prevy
        return None


    def collidebow(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	c = i.collidebow(self,player)
		if c:
			return i ## NOTE : returns collided entity (single)
##		self.relativex = self.prevx
##		self.relativey = self.prevy
        return None

    def collideknife(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	c = i.collideknife(self,player)
		if c:
			return i ## NOTE : returns collided entity (single)
##		self.relativex = self.prevx
##		self.relativey = self.prevy
        return None
