
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from stateimagelibrary import *
from playerbase import *
from rng import *
from broadsword import *
from rubysword import *
from inventorybow1 import *
from arrow import *
from knife import *
from bow1 import *

class PlayerLink(PlayerBase):
    "Player"
    def __init__(self,heartmeter):
        PlayerBase.__init__(self,PlayerBase.DROW,PlayerBase.MAGICUSER,heartmeter)
        
        self.stimlibright = Stateimagelibrary()	
        image = pygame.image.load('./pics/player1-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/player2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/player3-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/player2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)

	self.stimlibleft = Stateimagelibrary()	
        image = pygame.image.load('./pics/playerleft1-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/playerleft2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/playerleft3-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/playerleft2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)

        self.stimlibfight = Stateimagelibrary()	
        image = pygame.image.load('./pics/playerfight1-48x48.bmp').convert()
        image.set_colorkey((0,0,0))
        self.stimlibfight.addpicture(image)

        self.stimlibclimbing = Stateimagelibrary()	
        image = pygame.image.load('./pics/player-climbing-48x48.bmp').convert()
        image.set_colorkey((0,0,0))
        self.stimlibclimbing.addpicture(image)

        self.stimlibduck = Stateimagelibrary()	
        image = pygame.image.load('./pics/playerduck1-48x48.bmp').convert()
        image.set_colorkey((0,0,0))
        self.stimlibduck.addpicture(image)

        self.hitpoints = 100
        self.maxhitpoints = self.hitpoints
       	self.weapon = Knife(0,0,0,0,self)

        self.duck = 0
        self.jumpcounter = 0
 
    def askclass(self):
        return "Rogue"

    def askrace(self):
        return "Elf"

    def askpicture(self):
        return './pics/taskbar-PC.bmp'

    def collidewithenemyweapon(self,room,o):
        #FIXME2
        if o.collide(room,self):
		return self ## NOTE : returns collided entity (single)
		
	return None

    def hitwithenemyweapon(self,damage):
	if damage > 0:
		print 'player is hit!'
                self.hitpoints -= damage

    def pickup(self,room):
        n = room.pickup(self)
	return n

    def fight(self,room,game,player):
        self.fightcounter = 1

        if game.room.inventoryitem and game.room.inventoryitem.id == Inventorybow1().id:
            o = room.collidebow(self)
	    if o:
		if player.x-room.relativex < o.x: 
			room.gameobjects.append(Arrow(player.x+player.w+10-room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
		else:
			room.gameobjects.append(Arrow(player.x-10+room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
		print "fight scored hit on %s bow!" % o
		o.hitwithweapon(self.weapon.roll())
        else:
            #o = room.collidesword(self)
            o = room.collideknife(self)
            if o:
                if player.x-room.relativex < o.x:# and abs(player.y+room.relativey-o.y) <= 30:
			room.gameobjects.append(Knife(player.x+player.w+10+room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
		else:
			room.gameobjects.append(Knife(player.x-10+room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
      
                print "fight scored hit on %s knife!" % o
                o.hitwithweapon(self.weapon.roll())

    def jump(self, room):
        self.jumpcounter = 20
        ##FIXME1 self.direction = 'north'

    def update(self,room):
       if self.jumpcounter > 0 and self.jumpcounter < 140:
            room.relativey += 20
            self.jumpcounter += 15
       else:   
            self.jumpcounter = 0
            
    def setrubysword(self):
	self.weapon = RubySword(0,0)

    def setbow(self):
	self.weapon = Bow1(0,0)
	
